## file: karp.py -- correction td7
##
## implements Rabin-Karp algorithm


## implements Horner algorithm to computes a polynomial function at a
## given point
##
## format: pol is a list of integers, x an integer. horner(pol,x)
## returns the value of the polynomial c[0]+c[1]X+...+c[n]X^n at point
## x.
def horner(pol,x):
  n,coef = len(pol),pol[::-1]
  b = coef[0]
  for i in range(1,n):
    b = coef[i]+x*b
  return b

## format: w is a string of digits. str2int(w) returns the integer
## read in w from right to left.
def str2int(w):
  return horner([int(x) for x in w],10)

## base 10 version of RK, without moding.
##
## format: c,m are strings of digits. rk_match(m,c) returns the list
## of those i such that c[i:] admits m as a prefix.
def rk_match(m,c):
  l,k = len(m),len(c)
  mm,cc = str2int(m),str2int(c[:l])
  p = 10**(l-1)
  li = []
  for i in range(k-l+1):
    if cc==mm: li += [i]
    if i<k-l:
      cc = (cc//10)+p*int(c[i+l])
  return li

## base 10 version of RK, with moding.
##
## format: c,m are strings of digits, d is a integer. rk_match(m,c,k)
## returns the list of those i such that c[i:] admits m as a prefix.
def rk_match(m,c,d):
  l,k = len(m),len(c)
  mm,cc = str2int(m) % d, str2int(c[:l]) % d
  p = reduce(lambda x,y: (x*y) % d,[10]*(l-1),1)
  li = []
  for i in range(k-l+1):
    print i, ':', cc, mm, 
    if cc==mm:
      if c[i:i+l] == m: # double checking, avoiding false positive
        li += [i]
    if i<k-l:
      print c[i+l]
      cc = ((cc//10)+p*int(c[i+l])) % d
  return li


print rk_match("31","1829102819201062382923101209238239",10001)
